/** ngon.cpp
*
*   Demonstrate OpenGL functions
*
**/
#define WIN32_LEAN_AND_MEAN
#include <stdlib.h>
#include <math.h>
#include <windows.h>
#include "GLapplic.h"

void ngon( double radius, double rotAngle, int n)
{
	const double pi = 4.0*atan(1.0);
	if(n<3) return ; //bad number of sides
	rotAngle *= pi/180; // covnert initial angle to radians.
	double angleInc = (2 * pi) / n;  //angle increment
	double angle;
	glBegin(GL_LINE_LOOP);
	for (int k=0; k<n; k++) {
		angle = rotAngle+k*angleInc;
		glVertex2d(radius*cos(angle),radius*sin(angle));
	}
	glEnd();
}


class MyApp: public CAppWindow
{
public:
	MyApp();
	void OnSize(int cx, int cy);
	void DrawScene();
};

MyApp::MyApp(): CAppWindow("ngon")
{
	Width  = 320 ;
	Height = 320 ;
}

void MyApp::OnSize(int cx, int cy)
{
	GLsizei glnWidth, glnHeight;

	glnWidth = (GLsizei) cx;
	glnHeight = (GLsizei) cy;
	glMatrixMode(GL_PROJECTION); 
	glLoadIdentity();
	double w=1;
	gluOrtho2D(-w,w,-w-0.1,w+0.1);
	glViewport(0,0,glnWidth,glnHeight);	
}

void MyApp::DrawScene()
{
	glClearColor(1.0,1.0,1.0,0.0);       // set white background color
	glClear(GL_COLOR_BUFFER_BIT);     // clear the screen 
	glColor3f(0.0f, 0.0f, 0.0f);          // set the drawing color
	ngon(1.0,18.0,5);
	glFlush();		                 // send all output to display 
}

int Main()
{
	return MyApp().Run();
}
